
/**
 * Handle customizations
 * 
 * @param {*} options 
 */
function Customization(options) {
    this._log = require('log4js').getLogger('customization');
    this._log.setLevel('ERROR');

    this._instance = undefined;
    this._options = options;

    this._intialize(options);
}

Customization.prototype._intialize = function(options) {

    var C = require('../../../' + options.module + '/customization.js');
    this._instance = new C(options);

}

Customization.prototype.registerExpress = function(app) {
    this._instance.registerExpress(app);
}

Customization.prototype.registerExpressRoutes = function(app) {
    this._instance.registerExpressRoutes(app);
}

Customization.prototype.getGlobalOverrides = function() {
    return this._instance.getGlobalOverrides();
}

module.exports = Customization;