/*******************************************************************************
 client_frame.js: client class for a target frame

 $Author: dmc $
 $Revision: 2569 $
 $Date: 2019-05-18 21:03:07 -0300 (Sat, 18 May 2019) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/public/javascripts/client_frame.js $
*******************************************************************************/

// Frame: a physical target stand usable with any TargetFace

// everything in 'data' is synced with the server
// everything else is client-side only

function ClientFrame(data) {
	this.data = data;
	
	// just in case server didn't send it
	if (!data.string_params) data.string_params = {};
	
	//log("creating frame: " + data.name);

	this.crud = function(delta) {
		var msg = new_crud();
		msg.frames[this.id()] = delta;
		log("frame.crud()", msg);
		g_socket.emit("crud", msg);
	}

	this.id = function() {
		return this.data._id;
	}

	// currently active string
	this.string = function() {
		return g_strings[this.data.string_id];
	}
	
	// this.chosen_distance MIGHT be set to e.g. { "d": 1000 * YARDSTOMETRES, "name": "1000y", "unit": "y", "p": "true" }
	
	this.calc_mm_to_moa = function() {
		var dist_metres;
		var face = this.string().face();
		if ('object' == typeof this.chosen_distance) {
			dist_metres = chosen_distance.d;
		} else { // use default
			dist_metres = face.data.distance;
		}
		return face.calc_mm_to_moa(dist_metres);
	};
	
	// currently associated device
	this.device = function() {
		if (!this.data.assoc_device_id) return null;
		return g_devices[this.data.assoc_device_id];
	}

}

